'''data.py - simple data loader/saver module'''

import os
import shutil


DATA_DIR = 'data'
USER_DATA_DIR = '.wound-up/data'


def filepath(filename):
    '''determine the path to a file in the data directory'''
    return os.path.join(DATA_DIR, filename)


def load(filename, mode='rb'):
    '''open a file in the data directory for reading'''
    return open(os.path.join(DATA_DIR, filename), mode)

def userload(filename, mode='rb'):
    '''open a file in the user data directory for reading'''
    udatadir=os.path.join(os.getenv("HOME"),USER_DATA_DIR)
    filepath=os.path.join(udatadir, filename)
    if not os.path.exists(udatadir):
        os.makedirs(udatadir)
    if not os.path.exists(filepath):
        shutil.copyfile(os.path.join(DATA_DIR, filename), filepath)
    return open(filepath, mode)

def save(filename, mode='wb'):
    '''open a file in the data directory for writing'''
    return open(os.path.join(DATA_DIR, filename), mode)

def usersave(filename, mode='wb'):
    '''open a file in the user data directory for writing'''
    udatadir=os.path.join(os.getenv("HOME"),USER_DATA_DIR)
    filepath=os.path.join(udatadir, filename)
    if not os.path.exists(udatadir):
        os.makedirs(udatadir)
    if not os.path.exists(filepath):
        shutil.copyfile(os.path.join(DATA_DIR, filename), filepath)
    return open(filepath, mode)
